'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.concurrent = exports.limit = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var current = [];
var backlog = [];
var limit = exports.limit = parseInt(process.env.RATE_LIMIT || '5', 10);
var concurrent = exports.concurrent = function concurrent(fn) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  var enqueue = function enqueue(_ref) {
    var _ref2 = (0, _toArray3.default)(_ref);

    var promise = _ref2[0];
    var resolve = _ref2[1];
    var fn2 = _ref2[2];

    var args2 = _ref2.slice(3);

    current.push(promise);
    resolve(fn2.apply(undefined, (0, _toConsumableArray3.default)(args2)));
    promise.then(function (res) {
      current.splice(current.indexOf(promise), 1);

      if (current.length < limit && backlog.length > 0) {
        enqueue(backlog.pop());
      }
      return res;
    });
    return promise;
  };

  var resolve = void 0;
  var promise = new _promise2.default(function (res) {
    resolve = res;
  });

  if (current.length < limit) {
    enqueue([promise, resolve, fn].concat(args));
  } else {
    backlog.push([promise, resolve, fn].concat(args));
  }

  return promise;
};